! This subroutine Computes Voting Outcomes

subroutine voting

use params
implicit none
!Variables for Voting

double precision, dimension(ng,ne,nh,ns,na,J) :: Vot
double precision, dimension(ne,nh,J) :: Votebar
double precision, dimension(J) :: Votage
double precision :: votitt

double precision :: dummy
double precision :: onmedicaid(3,J)

! Voting by productivity, asset position and age
    do gc=1,ng
    do ec=1,ne
    do hc=1,nh
    do sc=1,ns
    do ac=1,na
    do tc=1,J
    
    Vot(gc,ec,hc,sc,ac,tc)=0
    
        if ( V2(gc,ec,hc,sc,ac,tc) .ge. V1(gc,ec,hc,sc,ac,tc) ) then 
        Vot(gc,ec,hc,sc,ac,tc)=1
        end if
        
    end do
    end do
    end do
    end do
    end do
    end do

! Total votes for a reform
votitt=0
votebar=0

    do tc=1,J
    do ec=1,ne
    do hc=1,nh
        do gc=1,ng
        do sc=1,ns
        votebar(ec,hc,tc)=votebar(ec,hc,tc)+sum(Vot(gc,ec,hc,sc,1:na,tc)*Phissadjusted1(gc,ec,hc,sc,1:na,tc))
        end do
        end do
    votitt=votitt+Nu(ec,hc,tc,2)*votebar(ec,hc,tc)/sum(Nu(:,:,:,2))
    end do
    end do
    end do


! Voting by age

votage=0
    do tc=1,J
    do ec=1,ne
    do hc=1,nh
    do gc=1,ng
    do sc=1,ns
    votage(tc)=votage(tc)+sum(Phissage1(gc,ec,hc,sc,1:na,tc)*Vot(gc,ec,hc,sc,1:na,tc))
    end do
    end do
    end do
    end do
    end do

onmedicaid=0

    do tc=1,J
    do ec=1,ne
    do hc=1,nh
    do gc=1,ng
    do sc=1,ns
    onmedicaid(1,tc)=onmedicaid(1,tc)+sum(Phissage1(gc,ec,hc,sc,1:na,tc)*g_dmss1(gc,ec,hc,sc,1:na,tc))
    onmedicaid(2,tc)=onmedicaid(2,tc)+sum(Phissage3(gc,ec,hc,sc,1:na,tc)*g_dmss3(gc,ec,hc,sc,1:na,tc))
    onmedicaid(3,tc)=onmedicaid(3,tc)+sum(Phissagetime(gc,ec,hc,sc,1:na,tc)*g_dmsstime(gc,ec,hc,sc,1:na,tc))
    end do
    end do
    end do
    end do
    end do
	

    if ( rank .eq. 0 ) then
    
        open(unit=1,file='output_voting.txt')
        write(1,*)'total_votes_for_reform ',votitt
        write(1,*)'age votes mcaid1 mcaid3 mcaidtime'
            do tc=1,J
            write(1,'(I2,300F12.5)')19+tc,votage(tc),onmedicaid(:,tc)
            end do
        close(1)	
        
    end if

end subroutine voting